"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.walkSync = walkSync;
exports.rmdir = rmdir;
exports.mkdir = mkdir;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

function walkSync(rootFolder) {
  var subFolder = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var ignoreHidden = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var resultPaths = [];

  var paths = _fs["default"].readdirSync(_path["default"].join(rootFolder, subFolder));

  if (paths != null && paths.length > 0) {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = paths[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var file = _step.value;
        file = _path["default"].join(subFolder, file);

        var realFile = _path["default"].join(rootFolder, file);

        var stat = _fs["default"].statSync(realFile);

        if (stat && stat.isDirectory()) {
          resultPaths = resultPaths.concat(walkSync(rootFolder, file) || []);
        } else {
          resultPaths.push(file);
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator["return"] != null) {
          _iterator["return"]();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  return resultPaths;
}

function rmdir(dir) {
  try {
    var list = _fs["default"].readdirSync(dir);

    for (var i = 0; i < list.length; i++) {
      var filename = _path["default"].join(dir, list[i]);

      var stat = _fs["default"].statSync(filename);

      if (filename === '.' || filename === '..') {} else if (stat.isDirectory()) {
        rmdir(filename);
      } else {
        _fs["default"].unlinkSync(filename);
      }
    }

    _fs["default"].rmdirSync(dir);
  } catch (ex) {}
}

function mkdir(p) {
  var root = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var dirs = p.split(_path["default"].sep);
  var dir = dirs.shift();
  root = (root || '') + dir + _path["default"].sep;

  try {
    _fs["default"].mkdirSync(root, 493);
  } catch (ex) {
    if (!_fs["default"].statSync(root).isDirectory()) {
      throw new Error(ex);
    }
  }

  return !dirs.length || mkdir(dirs.join(_path["default"].sep), root);
}